#ifndef	KBD_GLIB_H
#define	KBD_GLIB_H

#include <glib.h>
#include <stdio.h>
#include <xpanel/xpanel_visibility.h>

struct xpanel_kbd;

enum kbd_idle_state {
	KBD_IDLE_NONE	= 0,
	KBD_IDLE_START,		/* 1-shot */
	KBD_IDLE_KEEP_GOING,
	KBD_IDLE_STOPPED,
	KBD_IDLE_STOP,		/* 1-shot */
};

typedef int (*kbd_notifykeys_t)(struct xpanel_kbd *kbd);
typedef int (*kbd_callback_t)(struct xpanel_kbd *kbd, void *user_data);

struct xpanel_kbd {
	GSource			gsource;	/* must be first */
	struct pcp_device	*pcpdev;
	kbd_notifykeys_t	notifykeys;	/* Need to process keybuf */
	uint8_t			keybuf[BUFSIZ];
	uint8_t			numkeys;
	struct timeval	tv;
	struct timeval	lastkey;
	/* "screen-saver" callback */
	kbd_callback_t	kbd_idle_callback;
	void		*kbd_idle_data;
	uint32_t	kbd_idle_seconds;
	enum kbd_idle_state	idle_state;
};

XPANEL_API	struct xpanel_kbd *kbd_glib_register(struct pcp_device *pcpdev, GMainContext *mainctx, kbd_notifykeys_t notifykeys);
XPANEL_API	void kbd_glib_destroy(struct xpanel_kbd *kbd);
XPANEL_API	void kbd_flush(struct xpanel_kbd *kbd);
XPANEL_API	void kbd_idle_set_callback(struct xpanel_kbd *kbd, kbd_callback_t callback, void *user_data);
XPANEL_API	void kbd_idle_set_timeout(struct xpanel_kbd *kbd, uint32_t seconds);
XPANEL_API	void kbd_idle_reset(struct xpanel_kbd *kbd);
XPANEL_API	const char *idle_state_name(enum kbd_idle_state state);

#endif	/* KBD_GLIB_H */
