#ifndef	PCPSCREEN_H
#define	PCPSCREEN_H
/*
 * Written by Oron Peled <oron@actcom.co.il>
 * Copyright (C) 2009, Xorcom
 *
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/*
 * PCPSCREEN - Panel screen representation
 */

#include <stdint.h>
#include <xpanel/xpanel_visibility.h>

/* Forward declaractions */
struct xpw_screen;

/*
 * Screen handling (abstract)
 */
XPANEL_API	struct xpw_screen *xpw_screen_new(void *priv);
XPANEL_API	void xpw_screen_destroy(struct xpw_screen *screen);
XPANEL_API	struct pcp_device *xpw_screen_getphys(const struct xpw_screen *screen);
XPANEL_API	void xpw_screen_nesting(struct xpw_screen *screen, int nesting);
XPANEL_API	void xpw_screen_clear(struct xpw_screen *screen);
XPANEL_API	void xpw_screen_where(struct xpw_screen *screen, int *x, int *y);
XPANEL_API	void xpw_screen_gotoxy(struct xpw_screen *screen, int x, int y);
XPANEL_API	void xpw_screen_string(struct xpw_screen *screen, const char *str);
XPANEL_API	void xpw_screen_beep(struct xpw_screen *screen, int usec);

#endif	/* PCPSCREEN_H */
