#ifndef	XPW_BACKGROUND_H
#define	XPW_BACKGROUND_H

/*
 * Xorcom Panel Widgets - Editbox
 */

#include <xpanel/xpw.h>
#include <xpanel/xpw_menu.h>

#define	BACKGROUND_MAXWIDTH	40
#define	BACKGROUND_COLUMNS	16	/* Hardware limit */
#define	BACKGROUND_LINES	20

struct xpw_background {
	struct xpw		myself;	/* WARNING: must be first */
	char			contents[BACKGROUND_LINES][BACKGROUND_MAXWIDTH + 1];	/* for '\0' */
	struct xpw		*toplevel;
	int			line_insert;
	int			line_show;
	int			start_column;
};

XPANEL_API	int xpw_background_construct(struct xpw_background *xpw_background, struct xpw *toplevel, const char *logo);
XPANEL_API	int xpw_background_startup(struct xpw *toplevel, const char *logo);
XPANEL_API	struct xpw_background *xpw_background_get(void);
XPANEL_API	int xpw_background_addstring(struct xpw_background *background, const char *str);

XPANEL_PRIVATE	int xpw_background_register(void);
XPANEL_PRIVATE	void xpw_background_unregister(void);

#endif	/* XPW_BACKGROUND_H */
