#ifndef	XPW_IPADDR_H
#define	XPW_IPADDR_H

/*
 * Xorcom Panel Widgets - IP-Address box
 */

#include <arpa/inet.h>
#include <xpanel/xpw.h>

#define	XPW_IPADDR_MAXWIDTH	INET_ADDRSTRLEN

struct xpw_ipaddr {
	struct xpw		myself;	/* WARNING: must be first */
	struct in_addr		inet_addr;
	char			prompt[XPW_IPADDR_MAXWIDTH + 1];	/* for '\0' */
	char			contents[XPW_IPADDR_MAXWIDTH + 1];	/* for '\0' */
	int			cursor_pos;
};


XPANEL_API	int xpw_ipaddr_set(struct xpw *widget, uint32_t addr);
XPANEL_API	void xpw_ipaddr_result(struct xpw_ipaddr *xpw_ipaddr, char output[], size_t outlen);
XPANEL_API	int xpw_ipaddr_construct(struct xpw_ipaddr *xpw_ipaddr, const char *prompt, uint32_t net_addr);

XPANEL_PRIVATE	int xpw_ipaddr_register(void);
XPANEL_PRIVATE	void xpw_ipaddr_unregister(void);

#endif	/* XPW_IPADDR_H */
