#ifndef	XPW_MENU_H
#define	XPW_MENU_H

/*
 * Xorcom Panel Widgets - Menus
 */

#include <xpanel/xpw.h>

#define	MAX_MENU_ITEMS	10
#define MAX_MENU_NOTIFIER_LOGO_LEN 16

struct xpw_menu_entry {
	struct xpw	*widget;
	char		*text;
};

struct xpw_menu_notifier {
	struct xpw		myself;	/* WARNING: must be first */
	char			logo[MAX_MENU_NOTIFIER_LOGO_LEN + 1];
};

struct xpw_menu {
	struct xpw		myself;	/* WARNING: must be first */
	struct xpw_menu_entry	*entries[MAX_MENU_ITEMS];
	int			curr_entry;
};

XPANEL_API	int xpw_menu_notifier_construct(struct xpw_menu_notifier *notifier, const char prompt[], const char logo[]);
XPANEL_API	void xpw_menu_notifier_set_logo(struct xpw_menu_notifier *notifier, const char logo[]);

XPANEL_PRIVATE	int xpw_menu_notifier_register(void);
XPANEL_PRIVATE	void xpw_menu_notifier_unregister(void);

XPANEL_API	int xpw_menu_entry_construct(struct xpw_menu_entry *me, struct xpw *widget, char text[]);
XPANEL_API	void xpw_menu_entry_clear(struct xpw_menu_entry *me);
XPANEL_API	int xpw_menu_addentry(struct xpw_menu *xpw_menu, struct xpw_menu_entry *menu_entry);
XPANEL_API	int xpw_menu_delentry(struct xpw_menu *xpw_menu, int pos);
XPANEL_API	int xpw_menu_construct(struct xpw_menu *xpw_menu, const char name[]);
XPANEL_API	void xpw_menu_clear(struct xpw_menu *xpw_menu);

XPANEL_PRIVATE	int xpw_menu_register(void);
XPANEL_PRIVATE	void xpw_menu_unregister(void);

#endif	/* XPW_MENU_H */
