#ifndef	XPW_PASSWD_H
#define	XPW_PASSWD_H

/*
 * Xorcom Panel Widgets - Password entry
 */

#include <xpanel/xpw.h>
#include <xpanel/xpw_hotkeys.h>

#define	PASSWD_MAXWIDTH	16

struct xpw_passwd {
	struct xpw		myself;	/* WARNING: must be first */
	char			login[PASSWD_MAXWIDTH + 1];
	char			contents[PASSWD_MAXWIDTH + 1];	/* for '\0' */
	int			cursor_pos;
	int			facade_char;
};

XPANEL_API	int  xpw_passwd_construct(struct xpw_passwd *ui_passwd, const char *login, const uint64_t *mask_wanted);
XPANEL_API	int  xpw_passwd_read(struct xpw_passwd *ui_passwd, char *buf, size_t buflen);
XPANEL_API	int  xpw_passwd_set_facade(struct xpw_passwd *ui_passwd, int facade_char);

#define	XPW_PASSWD_NO_FACADE	(-1)

XPANEL_PRIVATE	int  xpw_passwd_register(void);
XPANEL_PRIVATE	void xpw_passwd_unregister(void);

#endif	/* XPW_PASSWD_H */
